/* ========================================
Ten projekt przedstawia prosty sposob uzycia statycznego wyswietlacza segmentowego LCD w ukladzie PSOC.
Przetwornik ADC SAR mierzy napiecie na potencjometrze, wmontowanym w plytke.
Wynik pomiaru zamieniany na cyfry i przekazywany na wyswietlacz.
 * ========================================
*/
#include <project.h>


uint16 result;
uint8 dataReady = 0u;

CY_ISR(ADC_SAR_2_ISR_LOC)
{
        result = CY_GET_REG16(ADC_SAR_2_SAR_WRK_PTR);
        dataReady = 1u;
}


int main()
{
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    //rozpoczecie dzialania wyswietlacza
    LCD_SegStatic_1_Start();

    //zmienne potrzebne do pozniejszej konwersji
    float res=0;
    uint8 cyfra1=0;
    uint8 cyfra2=0;
    int resbuf;

    //inicjalizacja przetwornika
    ADC_SAR_2_Start();
    ADC_SAR_2_IRQ_StartEx(ADC_SAR_2_ISR_LOC);
    ADC_SAR_2_StartConvert();
    
    //wlaczenie kropki pomiedzy cyframi wyswietlacza
    LCD_SegStatic_1_WritePixel(4, LCD_SegStatic_1_PIXEL_STATE_ON);


    CyGlobalIntEnable; /* Uncomment this line to enable global interrupts. */
    for(;;)
    {
        /* Place your application code here. */
      
        
        if(dataReady != 0u)
        {
            //zamiana wyniku pomiaru napiecia na potencjometrze na cyfry - napisana chalupniczo, polecam napisac inaczej
            cyfra1=0;
            cyfra2=0;
            res = ADC_SAR_2_CountsTo_Volts(result)*10;
            resbuf = (int)res;

            while (resbuf > 10)
            {
                cyfra2 = cyfra2+1;
                resbuf=resbuf-10;
            }
            
            if (resbuf==10) 
            {
                cyfra2 = cyfra2+1;
                resbuf=resbuf-10;
            }
        
            while (resbuf > 0)
            {
                cyfra1 = cyfra1+1;
                resbuf=resbuf-1;
            }
            
            //wpisanie wyniku konwersji na wyswietlacz
            LCD_SegStatic_1_Write7SegDigit_0(cyfra1, 0);
            LCD_SegStatic_1_Write7SegDigit_0(cyfra2, 1);
            dataReady = 0u;
        }
        

        //CyDelay(10);
    }
}

/* [] END OF FILE */
